--[[
************************************************************************
Project				: SKG
Author				: zhinjio
Project Revision	: r148
Project Date		: 20090516182656

File				: SKG_GUI_Sync.lua
Commit Author		: zhinjio
Commit Revision		: 118
Commit Date			: 20081030164922
************************************************************************
Description	:
	Sync frame and its associated functions.

TODO		:

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]
local SKG = LibStub( "AceAddon-3.0"):GetAddon( "SKG" )
local SKGL = LibStub( "AceLocale-3.0"):GetLocale( "SKG" )

function SKG_SYFItemButton_OnClick( bIndex )

	local db = SKG.db.profile

	-- find out the currently displayed list
	local currList = SKG_ActiveListTitle:GetText()
	if ( currList == nil ) then
		-- don't request anything. In fact, not sure this code can
		-- ever be reached
	else
		-- figure out what name is on the current button. Thats
		-- who we're going to send the request to
		local currPlayer = SKG_SYF_NameListItem[bIndex]:GetText()
		-- get the long hash to send along... (button only contains short hash)
		local latestTID = SKG_GetLatestTID( db.Log[currList] )
		local longHash = SKG_HashRollList( latestTID, currList )
		local payload = { currList, longHash }
		SKG_SendComm( "SYNRL", payload, "WHISPER", currPlayer )
	end
end

-- Sync Frame creation

SKG_SyncFrame = CreateFrame( "Frame", "SKG_SyncFrame", SKG_Frame )
	SKG_SyncFrame:SetClampedToScreen( true )
	SKG_SyncFrame:SetHeight( 371 )
	SKG_SyncFrame:SetWidth( 265 )
	SKG_SyncFrame:SetPoint( "TOPLEFT", SKG_Frame, "TOPRIGHT", 0, -50 )
	SKG_SyncFrame:EnableMouse( true )
	SKG_SyncFrame:SetMovable( true )
	SKG_SyncFrame:SetFrameLevel( 1 )
	SKG_SyncFrame:SetFrameStrata( "BACKGROUND" )
	SKG_SyncFrame:SetHitRectInsets( 5, 5, 5, 5 )
	SKG_SyncFrame:Hide()

	local SKG_SYF_Texture = SKG_SyncFrame:CreateTexture( "SKG_SYF_Texture", "ARTWORK" )
		SKG_SYF_Texture:SetTexture( [[Interface\Addons\SKG\BLP\SyncFrame_Texture]] )
		SKG_SYF_Texture:SetAllPoints( SKG_SyncFrame )
		SKG_SYF_Texture:SetTexCoord( (( 512 - 265 ) / 512 ), 1, 0, ( 371 / 512 ) )

	local SKG_SYF_TitleText = SKG_CreateButton("SKG_SYF_TitleText", SKG_SyncFrame, 14, 150,
		"TOP", SKG_SyncFrame, "TOP", 0, -3, "GameFontNormalSmall", "GameFontHighlightSmall",
		SKGL["SKG_LBL_SYF_TITLE_TEXT"], "CENTER", "SKG_SYF_TITLETEXT_TT", 0 )
		SKG_SYF_TitleText:SetScript( "OnClick", function ()
			local currList = SKG_ActiveListTitle:GetText()
			if ( currList == nil ) then
				SKG_Print( SKGL["SKG_ERROR_NOLISTSELECTED"] )
			else
				-- Clear out the current buttons, if any are displayed
				for i = 1, SKG_maxVisibleSYFListItems do
					SKG_SYF_NameListItem[i]:Hide()
					SKG_SYF_HashListItem[i]:Hide()
					SKG_currentSyncItems = 0
				end
				SKG_SendComm( "SYNRK", currList, "GUILD", nil )
			end
		end )

	local SKG_SYF_MyText = SKG_SyncFrame:CreateFontString( "SKG_SYF_MyText", "OVERLAY", "GameFontHighlight" )
		SKG_SYF_MyText:SetText( SKGL["SKG_LBL_SYF_MY_TEXT"] )
		SKG_SYF_MyText:SetPoint( "TOPLEFT", SKG_SyncFrame, "TOPLEFT", 5, -33 )
		SKG_SYF_MyText:SetJustifyH( "LEFT" )
		SKG_SYF_MyText:SetHeight( 14 )
		SKG_SYF_MyText:SetWidth( 105 )

--	local SKG_SYF_MyKeyText = SKG_SyncFrame:CreateFontString( "SKG_SYF_MyKeyText", "OVERLAY", "GameFontHighlightSmall" )
	local SKG_SYF_MyKeyText = SKG_SyncFrame:CreateFontString( "SKG_SYF_MyKeyText", "OVERLAY" )
		SKG_SYF_MyKeyText:SetFont( [[Fonts\ARIALN.TTF]], 11 )
		SKG_SYF_MyKeyText:SetText( "0" )
		SKG_SYF_MyKeyText:SetPoint( "TOPRIGHT", SKG_SyncFrame, "TOPRIGHT", -8, -33 )
		SKG_SYF_MyKeyText:SetJustifyH( "RIGHT" )
		SKG_SYF_MyKeyText:SetHeight( 14 )
		SKG_SYF_MyKeyText:SetWidth( 165 )

	SKG_SYF_NameListItem = { }
	for i = 1,SKG_maxVisibleSYFListItems do
			local Temp_ListItem = SKG_CreateButton("SKG_SYF_NameListItem" .. i, SKG_SyncFrame, 18, 94,
				"TOPLEFT", SKG_SyncFrame, "TOPLEFT", 0, -64, "GameFontNormalSmall", "GameFontHighlightSmall",
				"", "LEFT", "SKG_SYF_NAMELIST_TT", 0 )
			if not ( i == 1 ) then
				Temp_ListItem:SetPoint( "TOPLEFT", SKG_SYF_NameListItem[i-1], "BOTTOMLEFT", 0, -1 )
			end
			Temp_ListItem:SetText( "Acornchucker12" )
			Temp_ListItem:SetScript( "OnClick",
			function ()
				SKG_SYFItemButton_OnClick( i )
			end )
			Temp_ListItem:Hide()

			SKG_SYF_NameListItem[i] = Temp_ListItem
	end

	SKG_SYF_HashListItem = { }
	for i = 1,SKG_maxVisibleSYFListItems do
--			local Temp_ListItem = SKG_SyncFrame:CreateFontString( "SKG_SYF_HashListItem" .. i, "OVERLAY", "GameFontNormalSmall" )
			local Temp_ListItem = SKG_SyncFrame:CreateFontString( "SKG_SYF_HashListItem" .. i, "OVERLAY" )
			if not ( i == 1 ) then
				Temp_ListItem:SetPoint( "TOPRIGHT", SKG_SYF_HashListItem[i-1], "BOTTOMRIGHT", 0, -1 )
			else
				Temp_ListItem:SetPoint( "TOPRIGHT", SKG_SyncFrame, "TOPRIGHT", -8, -64 )
			end
			Temp_ListItem:SetHeight( 18 )
			Temp_ListItem:SetWidth( 165 )
			Temp_ListItem:SetJustifyH( "RIGHT" )

			Temp_ListItem:SetFont( [[Fonts\ARIALN.TTF]], 11 )

			Temp_ListItem:SetText( "1AB29EF8137291898DC120BA" )
			Temp_ListItem:Hide()

			SKG_SYF_HashListItem[i] = Temp_ListItem
	end



-- OnLoad stuff here

local font, size, style = SKG_SYF_MyKeyText:GetFont()
SKG_Debug( "font " .. font )
SKG_Debug( "size " .. size )
SKG_Debug( "style " .. style )

--[[
************************************************************************
CHANGELOG:

Date : 10/25/08
	Initial attempt with Ace3 instead of LibRock. Probably will require
	major edits once. Added header/footer. 
************************************************************************
]]--
